class mounts (
    String $fstab = '/etc/fstab',
    String $mode  = '0644',

    String $realize_tag = 'mounts',

    String $mount_cmd = '/bin/mount --all',
) {

    lookup('mounts', Hash[String, Any], 'deep', {}).each |String $name, Any $options| {
        ensure_resource(
            'mounts::mount',
            $name,
            $options
        )
    }

    Mounts::Mount <<| tag == $realize_tag |>>

    concat { $fstab:
        ensure         => present,
        mode           => $mode,
        order          => 'numeric',
        warn           => true,
        ensure_newline => true,
    }

    exec { 'update mounts':
        command     => $mount_cmd,
        refreshonly => true,
    }

    Mounts::Mount <| |> -> Concat[$fstab] ~> Exec['update mounts']
}
