define mounts::mount (
    String $fs,
    String $mountpoint = $name,
    String $type = $fs ? {
        'tmpfs' => 'tmpfs',
        default => 'ext4',
    },

    Array[String] $opts = ['defaults'],

    Integer $dump = 0,
    Integer $pass = $fs ? {
        'tmpfs' => 0,
        default => 2,
    },

    Integer $order = 10,
) {

    include mounts

    concat::fragment { "${fs} to ${mountpoint}":
        target  => $mounts::fstab,
        content => inline_epp('<%= $fs %>	<%= $mountpoint %>	<%= $type %>	<%= $opts.join(",") %>	<%= $dump %> <%= $pass %>'),
        order   => $order,
    }

}
